﻿function ImplementationOption(name_param, function_param){
	this.name = name_param;
	this.behavior = function_param;
}

function Attribute(name_param, default_value_param, mapper_param) {
	this.name = name_param;
	this.value = default_value_param;
	this.controlled_by_operations = mapper_param?mapper_param:[]; //array влияет на последовательность применения модификаций
}

function OperationMapper(mod_param, op_param){
	this.mod = mod_param;
	this.operation = op_param;//индекс на одну из операций в модификации, 
}

function MOperation(type_param, value_param, desc_param, attrs_idxs_param, user_input_param, formula_param){
	this.type = type_param;
	this.value = value_param;
	this.description = desc_param;
	this.modified_attributes = attrs_idxs_param; //array
	this.user_input = user_input_param?true:false;
	this.value_function = formula_param?formula_param:_undefined;
}

function Modification(name_param, mcost_param, operations_param){
	this.name = name_param;
	this.cost = mcost_param;
	this.operations = operations_param; //array
}

function Tech_Type(name_param, weight_factor_param){
	this.attr = [
		new Attribute("тип техники",name_param),
		new Attribute("коэф. утяжеления",weight_factor_param)
	];
}

function MDevice(name_param, 
				price_param, 
				size_param, 
				warming_param, 
				installed_param, 
				controlled_param, 
				desc_param, 
				controlled_area_param,
				weight_param,
				allowed_segments_param,
				max_count_param,
				options_param,
				composite_name_param,
				aditional_param,
				type_p){
	this.attr = [
		new Attribute("название",name_param),
		new Attribute("стоимость",price_param?price_param:0),
		new Attribute("занимаемое место",size_param?size_param:0),
		new Attribute("нагрев",warming_param?warming_param:0),
		new Attribute("вес",weight_param?weight_param:0),
		new Attribute("хиты оборудования",size_param?size_param*2:1),
		new Attribute("максимальное число установок", max_count_param?max_count_param:-1)
	];
	this.installed_in_segments = installed_param?installed_param:false;
	this.controlled_by_devices = controlled_param?controlled_param:false;
	this.description = desc_param?desc_param:false;
	this.controlled_area = controlled_area_param;
	this.allowed_segments = allowed_segments_param?allowed_segments_param:(installed_param?installed_param:[]);
	this.options = options_param?options_param:[device_allocation_types, device_implementation_types];
	this.selected_options = [];
	this.segment_index = null;
	this.composite_name = composite_name_param;//композитные девайсы рассасываются по группе сегментов
	this.aditional_param = aditional_param?aditional_param:null;
	this.type = type_p?type_p:_device;
}
MDevice.prototype.clone = function(seg_idx_param){
	var rdo = new MDevice(
		this.attr[_name].value,
		this.attr[_price].value,
		this.attr[_size].value,
		this.attr[_warming].value,
		this.installed_in_segments,
		this.controlled_by_devices,
		this.description,
		this.controlled_area,
		this.attr[_weight].value,
		this.allowed_segments,
		this.attr[_max_count].value,
		this.options,
		this.composite_name,
		this.aditional_param,
		this.type
	);
	rdo.segment_index = seg_idx_param;
	return rdo;
}

function MBattery(label_param, workload_param, price_param, size_param, weight_param){ //батареи и аккумуляторы
	this.device = new MDevice(
		"бат./акк.", price_param, size_param, 0, false,null,"энергоснабжение машины",_undefined,weight_param,
		[_sg_nose,_sg_cockpit,_sg_torso,_sg_hands,_sg_legs,_sg_tail,_sg_wings]);
	this.device.type = _battery;
	this.attr = [
		new Attribute("маркировка",label_param),
		new Attribute("лимит заряда",workload_param)
	];
}

function MEngine(label_param, workload_param, warming_param, size_param, price_param) {
	var tsp = 0; //size_param*100
	this.device = new MDevice(
		"двигатель",price_param, size_param, warming_param,	false, null,label_param,_undefined,	tsp, //weight
		[_sg_nose,_sg_cockpit,_sg_torso,_sg_hands,_sg_legs,_sg_tail,_sg_wings]);
	this.device.type = _engine;
	this.attr = [
		new Attribute("маркировка",label_param),
		new Attribute("рабочая нагрузка",workload_param + tsp)
	];
}

function MWeapon(name_param, price_param, size_param, warming_param, weight_param, range_param, add_seg_param, add_options){
	var tas = [_sg_nose,_sg_cockpit,_sg_torso,_sg_hands,_sg_tail,_sg_wings];
	if(add_seg_param)tas.push(_sg_legs);
	this.device = new MDevice(
		name_param, price_param, size_param, warming_param, false, 
		[[_default_weapon_connector], [_extra_weapon_connector]],
		"оружие",_undefined,weight_param,tas);
	this.device.options.push(weapon_allocation_types, weapon_angle, waxwork, heat_reduce);
	if(add_options) for(var i=0;i<add_options.length;i++){
		this.device.options.push(add_options[i]);
	}
	this.device.aditional_param = range_param;
	this.device.type = _weapon;
	this.attr = [
		new Attribute("дальность",range_param)
	];
}

function MMaterial(name_param, basic_damage_absorption_param, heat_conduction_param, weight_modifier_param, 
					durability_factor_param, prices_param, weights_param){
	this.attr = [
		new Attribute("наименование",name_param),
		new Attribute("базовое поглощение",basic_damage_absorption_param),
		new Attribute("теплопроводность",heat_conduction_param),
		new Attribute("модификатор веса",weight_modifier_param),
		new Attribute("коэф. прочности",durability_factor_param)
	];
	this.prices = prices_param;
	this.weights = weights_param;
}

function MStructure(name_param, cooling_param, techtype_param, config_param, speed_mf_param, speed_kf_param, capacity_factor_param, weight_factor_param, price_factor_param, asm_param) {
	this.tech_type = techtype_param;
	this.config = config_param; 
	this.attr = [
		new Attribute("ходовая",name_param),
		new Attribute("остывание ходовой",cooling_param),
		new Attribute("модификаторы скорости",speed_mf_param), //{a:шаговая, b:беговая}
		new Attribute("коэф. скорости корпуса",speed_kf_param), //{a:шаговая, b:беговая}
		new Attribute("коэф. места",capacity_factor_param),
		new Attribute("коэф. веса",weight_factor_param),
		new Attribute("коэф. цены",price_factor_param)
	];
	this.additional_speed_mod = asm_param;
}

function MSegment(name_param,group_param,hp_param,neighbors_param){
	this.attr = [
		new Attribute("название",name_param),
		new Attribute("группа",group_param), //типа это ноги, а это руки и т.д.
		new Attribute("хиты",hp_param?hp_param:0),
		new Attribute("занятое место",0)
	];
	this.supporting_segment = neighbors_param?neighbors_param:-1; //номер держащего сегмента
}

function MArmorPlate(_name_p, _heat_res_p, _dam_abs_p, _hit_point_ap, _weight_ap, _price_ap){
	this.name = _name_p;
	this.heat_resistance = _heat_res_p;
	this.damage_absorbtion = _dam_abs_p;
	this.hit_points = _hit_point_ap;
	this.weight = _weight_ap;
	this.price = _price_ap;
}